首页 > 其他 > 详细

【转载】曲线打断、求交点

时间:2020-02-22 23:43:45      阅读:68      评论:0      收藏:0      [点我收藏+]

在08科创项目,绘图助手工具箱中的第二、三个命令RTLine、STLine就是使用了曲线打断的函数,为实现这个命令我查阅了多个网页,找出了几个重要的函数,分别是打断曲线的getSplitCurves、求两曲线交点的intersectwith。感谢ObjectARX编程站,让我找到很多ObjectARX方面我需要的东西,以下就是我转载的文章:

 

 

创建自己的曲线打断命令

 原文地址:http://www.objectarx.net/bbs/viewthread.php?tid=1655&extra=page%3D1%26amp%3Bfilter%3Ddigest

技术分享图片
技术分享图片 void drawEntity(AcDbEntity* pEntity);
技术分享图片 bool breakCurve(AcDbCurve* curve, AcGePoint3d pt);
技术分享图片 bool breakCurve(AcDbCurve* curve, AcGePoint3d p1, AcGePoint3d p2);
技术分享图片
技术分享图片
技术分享图片 static void Mybreak2008_Mybreak(void)
技术分享图片 {
技术分享图片     // Add your code for command Mybreak2008._Mybreak here
技术分享图片     ads_point pt1,pt2;
技术分享图片     ads_name entName;
技术分享图片     Acad::ErrorStatus es;
技术分享图片     int ret;
技术分享图片     ACHAR kWord[100];
技术分享图片
技术分享图片
技术分享图片     if (acedEntSel(_T("\n选择所要打断的曲线:"), entName, pt1) !=RTNORM)
技术分享图片     {
技术分享图片         return;
技术分享图片     }
技术分享图片     AcDbObjectId entId;
技术分享图片     AcDbCurve *pCurve=NULL;
技术分享图片     AcDbEntity *pEnt = NULL;
技术分享图片     es = acdbGetObjectId(entId, entName);
技术分享图片     if (es != Acad::eOk)
技术分享图片     {
技术分享图片        return;
技术分享图片     }
技术分享图片     acdbOpenObject(pEnt, entId, AcDb::kForWrite);
技术分享图片     if (pEnt->isKindOf(AcDbCurve::desc()))
技术分享图片     {
技术分享图片        pCurve = AcDbCurve::cast(pEnt);
技术分享图片        if (pCurve != NULL)
技术分享图片        {
技术分享图片           acedInitGet (NULL, _T("F"));
技术分享图片           ret=acedGetPoint(NULL,_T("\n指定第二个打断点或[第一点(F)]:"),pt2);
技术分享图片           switch (ret)
技术分享图片           {
技术分享图片               case RTKWORD:
技术分享图片                   ret=acedGetInput(kWord);
技术分享图片                   if ( ret!= RTNORM )
技术分享图片                       break ;
技术分享图片                   acedInitGet(RSG_NONULL, _T(""));
技术分享图片                   ret=acedGetPoint(NULL,_T("\n指定第一个打断点:"),pt1);
技术分享图片                   if (ret!=RTNORM)
技术分享图片                       break;
技术分享图片                   acedInitGet(RSG_NONULL, _T(""));
技术分享图片                   ret=acedGetPoint(NULL,_T("\n指定第二个打断点:"),pt2);
技术分享图片                   if (ret!=RTNORM)
技术分享图片                      break;
技术分享图片                   breakCurve(pCurve,asPnt3d(pt1), asPnt3d(pt2));
技术分享图片                   break;
技术分享图片               case RTNONE:
技术分享图片                   breakCurve(pCurve,asPnt3d(pt1));
技术分享图片                   break;
技术分享图片                case RTNORM:
技术分享图片                   breakCurve(pCurve,asPnt3d(pt1), asPnt3d(pt2));
技术分享图片                    break;
技术分享图片              default:
技术分享图片                   break;
技术分享图片           }
技术分享图片        }
技术分享图片     }
技术分享图片     pEnt->close();
技术分享图片 }
技术分享图片
技术分享图片
技术分享图片 //以下为函数
技术分享图片 //打断于点
技术分享图片 bool breakCurve(AcDbCurve* curve,AcGePoint3d pt)
技术分享图片 {
技术分享图片     AcGePoint3d p1;
技术分享图片     curve->getClosestPointTo(pt,p1);
技术分享图片     double param;
技术分享图片     curve->getParamAtPoint(p1,param);
技术分享图片     AcGeDoubleArray params;
技术分享图片     params.append(param);
技术分享图片     AcDbVoidPtrArray curveSegments;
技术分享图片     curve->getSplitCurves(params, curveSegments);
技术分享图片     AcDbEntity* ent =NULL;
技术分享图片     if (curveSegments.length()==2)
技术分享图片     {
技术分享图片         ent=(AcDbEntity*)curveSegments[0];
技术分享图片         drawEntity(ent);
技术分享图片         ent->close();
技术分享图片         ent=(AcDbEntity*)curveSegments[1];
技术分享图片         drawEntity(ent);
技术分享图片         ent->close();
技术分享图片         curve->erase();
技术分享图片     }
技术分享图片     else
技术分享图片     {
技术分享图片         curve->close();
技术分享图片     }   
技术分享图片     return true ;
技术分享图片 }
技术分享图片 //两点打断
技术分享图片 bool breakCurve(AcDbCurve* curve, AcGePoint3d p1, AcGePoint3d p2)
技术分享图片 {
技术分享图片     AcGePoint3d p11;
技术分享图片     curve->getClosestPointTo(p1,p11);
技术分享图片     double param1;
技术分享图片     curve->getParamAtPoint(p11,param1);
技术分享图片     AcGePoint3d p21;
技术分享图片     curve->getClosestPointTo(p2,p21);
技术分享图片     double param2;
技术分享图片     curve->getParamAtPoint(p21,param2);
技术分享图片     AcGeDoubleArray params;
技术分享图片     if (param1<param2)
技术分享图片     {
技术分享图片         params.append(param1);
技术分享图片         params.append(param2);
技术分享图片     }
技术分享图片     else
技术分享图片     {
技术分享图片         params.append(param2);
技术分享图片         params.append(param1);
技术分享图片     }
技术分享图片     AcDbVoidPtrArray curveSegments;
技术分享图片     curve->getSplitCurves(params, curveSegments);
技术分享图片     AcDbEntity* ent =NULL;
技术分享图片     if (curveSegments.length()==2)
技术分享图片     {
技术分享图片         ent=(AcDbEntity*)curveSegments[1];
技术分享图片         drawEntity(ent);
技术分享图片         ent->close();
技术分享图片     }
技术分享图片     else if (curveSegments.length()==3)
技术分享图片     {
技术分享图片         ent=(AcDbEntity*)curveSegments[0];
技术分享图片         drawEntity(ent);
技术分享图片         ent->close();
技术分享图片         ent=(AcDbEntity*)curveSegments[2];
技术分享图片         drawEntity(ent);
技术分享图片         ent->close();
技术分享图片     }
技术分享图片     curve->erase();
技术分享图片     return true ;
技术分享图片 }
技术分享图片 //绘制打断的曲线
技术分享图片 void drawEntity(AcDbEntity* pEntity)
技术分享图片 {
技术分享图片     AcDbBlockTable *pBlockTable;
技术分享图片     acdbHostApplicationServices()->workingDatabase()
技术分享图片         ->getSymbolTable(pBlockTable, AcDb::kForRead);
技术分享图片     AcDbBlockTableRecord *brec;
技术分享图片     resbuf tilemode;
技术分享图片     acedGetVar(_T("TILEMODE"),&tilemode);
技术分享图片     int tile=tilemode.resval.rint;
技术分享图片     if (tile)
技术分享图片         pBlockTable->getAt(ACDB_MODEL_SPACE, brec,AcDb::kForWrite);
技术分享图片     else
技术分享图片         pBlockTable->getAt(ACDB_PAPER_SPACE, brec,AcDb::kForWrite);
技术分享图片     pBlockTable->close();
技术分享图片     AcDbObjectId entid;
技术分享图片     brec->appendAcDbEntity(entid, pEntity);
技术分享图片      brec->close();     
技术分享图片  }
技术分享图片

【转载】曲线打断、求交点

原文:https://www.cnblogs.com/mjgw/p/12347934.html

(0)
(0)
   
举报
评论 一句话评论(0
关于我们 - 联系我们 - 留言反馈 - 联系我们:wmxa8@hotmail.com
© 2014 bubuko.com 版权所有
打开技术之扣,分享程序人生!